Index: src/Actions/GlobalListOfActions.hpp
===================================================================
--- src/Actions/GlobalListOfActions.hpp	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ src/Actions/GlobalListOfActions.hpp	(revision 16c7dd3fc6c66022b4b13c912de169a1f812196c)
@@ -69,6 +69,4 @@
   (MoleculeChangeBondAngle) \
   (MoleculeCopy) \
-  (MoleculeFillWithMolecule) \
-  (MoleculeFillVoidWithMolecule) \
   (MoleculeForceAnnealing) \
   (MoleculeLinearInterpolationofTrajectories) \
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ src/Actions/Makefile.am	(revision 16c7dd3fc6c66022b4b13c912de169a1f812196c)
@@ -282,6 +282,4 @@
   Actions/MoleculeAction/ChangeNameAction.cpp \
   Actions/MoleculeAction/CopyAction.cpp \
-  Actions/MoleculeAction/FillWithMoleculeAction.cpp \
-  Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp \
   Actions/MoleculeAction/ForceAnnealingAction.cpp \
   Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
@@ -301,6 +299,4 @@
   Actions/MoleculeAction/ChangeNameAction.hpp \
   Actions/MoleculeAction/CopyAction.hpp \
-  Actions/MoleculeAction/FillWithMoleculeAction.hpp \
-  Actions/MoleculeAction/FillVoidWithMoleculeAction.hpp \
   Actions/MoleculeAction/ForceAnnealingAction.hpp \
   Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
@@ -320,6 +316,4 @@
   Actions/MoleculeAction/ChangeNameAction.def \
   Actions/MoleculeAction/CopyAction.def \
-  Actions/MoleculeAction/FillWithMoleculeAction.def \
-  Actions/MoleculeAction/FillVoidWithMoleculeAction.def \
   Actions/MoleculeAction/ForceAnnealingAction.def \
   Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def \
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,166 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
- * 
- *
- *   This file is part of MoleCuilder.
- *
- *    MoleCuilder is free software: you can redistribute it and/or modify
- *    it under the terms of the GNU General Public License as published by
- *    the Free Software Foundation, either version 2 of the License, or
- *    (at your option) any later version.
- *
- *    MoleCuilder is distributed in the hope that it will be useful,
- *    but WITHOUT ANY WARRANTY; without even the implied warranty of
- *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *    GNU General Public License for more details.
- *
- *    You should have received a copy of the GNU General Public License
- *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-/*
- * FillVoidWithMoleculeAction.cpp
- *
- *  Created on: May 10, 2010
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include "Atom/atom.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "Descriptors/MoleculeIdDescriptor.hpp"
-#include "Descriptors/MoleculeOrderDescriptor.hpp"
-#include "Graph/BondGraph.hpp"
-#include "molecule.hpp"
-#include "MoleculeListClass.hpp"
-#include "Parser/FormatParserInterface.hpp"
-#include "Parser/FormatParserStorage.hpp"
-#include "Tesselation/boundary.hpp"
-#include "World.hpp"
-
-
-#include <algorithm>
-#include <iostream>
-#include <string>
-
-#include "Actions/MoleculeAction/FillVoidWithMoleculeAction.hpp"
-
-using namespace MoleCuilder;
-
-// and construct the stuff
-#include "FillVoidWithMoleculeAction.def"
-#include "Action_impl_pre.hpp"
-/** =========== define the function ====================== */
-ActionState::ptr MoleculeFillVoidWithMoleculeAction::performCall() {
-  if (!boost::filesystem::exists(params.fillername.get())) {
-    STATUS("File with filler molecule "+params.fillername.get().string()+" does not exist!");
-    return Action::failure;
-  }
-
-  LOG(1, "INFO: Filling Box with water molecules, "
-      << " minimum distance to molecules" << params.boundary.get()
-      << ", random atom displacement " << params.RandAtomDisplacement.get()
-      << ", random molecule displacement " << params.RandMoleculeDisplacement.get()
-      << ", distances between fillers (" << params.distances.get()[0] << "," << params.distances.get()[1] << "," << params.distances.get()[2]
-      << "), MinDistance " << params.MinDistance.get()
-      << ", DoRotate " << params.DoRotate.get() << ".");
-  // construct water molecule
-  std::vector<molecule *> presentmolecules = World::getInstance().getAllMolecules();
-//  LOG(0, presentmolecules.size() << " molecules initially are present.");
-  std::string FilenameSuffix = params.fillername.get().string().substr(params.fillername.get().string().find_last_of('.')+1, params.fillername.get().string().length());
-  ifstream input;
-  input.open(params.fillername.get().string().c_str());
-  ParserTypes type = FormatParserStorage::getInstance().getTypeFromSuffix(FilenameSuffix);
-  FormatParserInterface &parser = FormatParserStorage::getInstance().get(type);
-  parser.load(&input);
-
-  // search the filler molecule that has been just parsed
-  molecule *filler = World::getInstance().getMolecule(MoleculeByOrder(-1)); // get last molecule
-  ASSERT(filler != NULL,
-      "MoleculeFillVoidWithMoleculeAction::performCall() - no last molecule found, nothing parsed?.");
-  filler->SetNameFromFilename(params.fillername.get().string().c_str());
-  World::AtomComposite Set = filler->getAtomSet();
-  World::getInstance().getBondGraph()->CreateAdjacency(Set);
-
-  // call routine
-  double distance[NDIM];
-  for (int i=0;i<NDIM;i++)
-    distance[i] = params.distances.get()[i];
-  FillVoidWithMolecule(
-      filler,
-      *(World::getInstance().getConfig()),
-      distance,
-      params.boundary.get(),
-      params.RandAtomDisplacement.get(),
-      params.RandMoleculeDisplacement.get(),
-      params.MinDistance.get(),
-      params.DoRotate.get());
-
-  // generate list of newly created molecules
-  // (we can in general remove more quickly from a list than a vector)
-  std::vector<molecule *> fillermolecules = World::getInstance().getAllMolecules();
-//  LOG(0, fillermolecules.size() << " molecules are present.");
-  std::list<molecule *> fillermolecules_list;
-  std::copy( fillermolecules.begin(),  fillermolecules.end(), std::back_inserter( fillermolecules_list ));
-//  LOG(0, fillermolecules_list.size() << " molecules have been copied.");
-  for (std::vector<molecule *>::const_iterator iter = presentmolecules.begin();
-      iter != presentmolecules.end();
-      ++iter) {
-    fillermolecules_list.remove(*iter);
-  }
-//  LOG(0, fillermolecules_list.size() << " molecules left after removal.");
-  fillermolecules.clear();
-  std::copy(fillermolecules_list.begin(), fillermolecules_list.end(), std::back_inserter( fillermolecules ));
-
-//  LOG(0, fillermolecules.size() << " molecules have been inserted.");
-
-  return ActionState::ptr(new MoleculeFillVoidWithMoleculeState(fillermolecules,params));
-}
-
-ActionState::ptr MoleculeFillVoidWithMoleculeAction::performUndo(ActionState::ptr _state) {
-  MoleculeFillVoidWithMoleculeState *state = assert_cast<MoleculeFillVoidWithMoleculeState*>(_state.get());
-
-  MoleculeListClass *MolList = World::getInstance().getMolecules();
-
-  BOOST_FOREACH(molecule *_mol, state->fillermolecules) {
-    MolList->erase(_mol);
-    if ((_mol != NULL) && (!(World::getInstance().getAllMolecules(MoleculeById(_mol->getId()))).empty())) {
-      for(molecule::iterator iter = _mol->begin();
-          !_mol->empty();
-          iter = _mol->begin()) {
-        atom *Walker = *iter;
-        World::getInstance().destroyAtom(Walker);
-      }
-      World::getInstance().destroyMolecule(_mol);
-    }
-  }
-
-  // as molecules and atoms from state are removed, we have to create a new one
-  std::vector<molecule *> fillermolecules;
-  return ActionState::ptr(new MoleculeFillVoidWithMoleculeState(fillermolecules,state->params));
-}
-
-ActionState::ptr MoleculeFillVoidWithMoleculeAction::performRedo(ActionState::ptr _state){
-  //MoleculeFillVoidWithMoleculeState *state = assert_cast<MoleculeFillVoidWithMoleculeState*>(_state.get());
-
-  STATUS("Redo for MoleculeFillVoidWithMoleculeAction not implemented.");
-  return Action::failure;
-  //return ActionState::ptr(_state);
-}
-
-bool MoleculeFillVoidWithMoleculeAction::canUndo() {
-  return true;
-}
-
-bool MoleculeFillVoidWithMoleculeAction::shouldUndo() {
-  return true;
-}
-/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.def
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.def	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/*
- * FillVoidWithMoleculeAction.def
- *
- *  Created on: Aug 26, 2010
- *      Author: heber
- */
-
-// all includes and forward declarations necessary for non-integral types below
-#include "LinearAlgebra/Vector.hpp"
-
-#include "LinearAlgebra/defs.hpp"
-#include "Parameters/Validators/DummyValidator.hpp"
-#include "Parameters/Validators/Ops_Validator.hpp"
-#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
-#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
-#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
-#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
-
-// i.e. there is an integer with variable name Z that can be found in
-// ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
-#define paramtypes (boost::filesystem::path)(Vector)(double)(double)(double)(double)(bool)
-#define paramtokens ("fill-void")("distances")("distance-to-molecule")("random-atom-displacement")("random-molecule-displacement")("distance-to-boundary")("DoRotate")
-#define paramdescriptions ("name of xyz file of filler molecule")("list of three of distances in space, one for each axis direction")("minimum distance to present molecules")("magnitude of random atom displacement")("magnitude of random molecule displacement")("minimum distance to boundary")("whether to rotate or not")
-#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(false))
-#define paramreferences (fillername)(distances)(boundary)(RandAtomDisplacement)(RandMoleculeDisplacement)(MinDistance)(DoRotate)
-#define paramvalids \
-(FilePresentValidator() && ParserFileValidator()) \
-(BoxVectorValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator()) \
-(DummyValidator< bool >())
-
-#define statetypes (std::vector<molecule *>)
-#define statereferences (fillermolecules)
-
-// some defines for all the names, you may use ACTION, STATE and PARAMS
-#define CATEGORY Molecule
-#define MENUNAME "molecule"
-#define MENUPOSITION 5
-#define ACTIONNAME FillVoidWithMolecule
-#define TOKEN "fill-void"
-
-
-// finally the information stored in the ActionTrait specialization
-#define DESCRIPTION "fill void space of box with a filler molecule"
-#undef SHORTFORM
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.hpp
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.hpp	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,22 +1,0 @@
-/*
- * FillVoidWithMoleculeAction.hpp
- *
- *  Created on: May 10, 2010
- *      Author: heber
- */
-
-#ifndef FILLVOIDWITHMOLECULEACTION_HPP
-#define FILLVOIDWITHMOLECULEACTION_HPP
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-
-#include "Actions/Action.hpp"
-
-#include "FillVoidWithMoleculeAction.def"
-#include "Action_impl_header.hpp"
-
-#endif // FILLVOIDWITHMOLECULEACTION_HPP
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,170 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
- * 
- *
- *   This file is part of MoleCuilder.
- *
- *    MoleCuilder is free software: you can redistribute it and/or modify
- *    it under the terms of the GNU General Public License as published by
- *    the Free Software Foundation, either version 2 of the License, or
- *    (at your option) any later version.
- *
- *    MoleCuilder is distributed in the hope that it will be useful,
- *    but WITHOUT ANY WARRANTY; without even the implied warranty of
- *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *    GNU General Public License for more details.
- *
- *    You should have received a copy of the GNU General Public License
- *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-/*
- * FillWithMoleculeAction.cpp
- *
- *  Created on: May 10, 2010
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include "Atom/atom.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "Descriptors/MoleculeIdDescriptor.hpp"
-#include "Descriptors/MoleculeOrderDescriptor.hpp"
-#include "Graph/BondGraph.hpp"
-#include "molecule.hpp"
-#include "MoleculeListClass.hpp"
-#include "Parser/FormatParserInterface.hpp"
-#include "Parser/FormatParserStorage.hpp"
-#include "Tesselation/boundary.hpp"
-#include "World.hpp"
-
-#include <iostream>
-#include <string>
-
-#include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
-
-using namespace MoleCuilder;
-
-// and construct the stuff
-#include "FillWithMoleculeAction.def"
-#include "Action_impl_pre.hpp"
-/** =========== define the function ====================== */
-ActionState::ptr MoleculeFillWithMoleculeAction::performCall() {
-
-  LOG(1, "INFO: Filling Box with water molecules, "
-      << " minimum distance to molecules" << params.boundary.get()
-      << ", random atom displacement " << params.RandAtomDisplacement.get()
-      << ", random molecule displacement " << params.RandMoleculeDisplacement.get()
-      << ", distances between fillers (" << params.distances.get()[0] << "," << params.distances.get()[1] << "," << params.distances.get()[2]
-      << "), MinDistance " << params.MaxDistance.get()
-      << ", DoRotate " << params.DoRotate.get() << ".");
-  // construct water molecule
-  std::vector<molecule *> presentmolecules = World::getInstance().getAllMolecules();
-//  LOG(0, presentmolecules.size() << " molecules initially are present.");
-  std::string FilenameSuffix = params.fillername.get().string().substr(params.fillername.get().string().find_last_of('.')+1, params.fillername.get().string().length());
-  ifstream input;
-  LOG(0, "STATUS: Loading filler molecule " << params.fillername.get().string().c_str()
-      << " of suffix " << FilenameSuffix << ".");
-  input.open(params.fillername.get().string().c_str());
-  FormatParserStorage::getInstance().load(input, FilenameSuffix);
-  input.close();
-
-  // search the filler molecule that has been just parsed
-  molecule *filler = World::getInstance().getMolecule(MoleculeByOrder(-1)); // get last molecule
-  ASSERT(filler != NULL,
-      "MoleculeFillWithMoleculeAction::performCall() - no last molecule found, nothing parsed?.");
-  filler->SetNameFromFilename(params.fillername.get().string().c_str());
-  World::AtomComposite Set = filler->getAtomSet();
-  LOG(1, "INFO: The filler molecules has " << Set.size() << " atoms.");
-  World::getInstance().getBondGraph()->CreateAdjacency(Set);
-
-  // TODO: Remove the erasure of molecule when saving does not depend on them anymore.
-  World::getInstance().getMolecules()->erase(filler); // remove it, Parser adds it automatically
-
-  // call routine
-  double distance[NDIM];
-  for (int i=0;i<NDIM;i++)
-    distance[i] = params.distances.get()[i];
-  FillBoxWithMolecule(
-      World::getInstance().getMolecules(),
-      filler, *(World::getInstance().getConfig()),
-      params.MaxDistance.get(),
-      distance,
-      params.boundary.get(),
-      params.RandAtomDisplacement.get(),
-      params.RandMoleculeDisplacement.get(),
-      params.DoRotate.get());
-  for (molecule::iterator iter = filler->begin(); !filler->empty(); iter = filler->begin()) {
-    atom *Walker = *iter;
-    World::getInstance().destroyAtom(Walker);
-  }
-  World::getInstance().destroyMolecule(filler);
-
-  // generate list of newly created molecules
-  // (we can in general remove more quickly from a list than a vector)
-  std::vector<molecule *> fillermolecules = World::getInstance().getAllMolecules();
-//  LOG(0, fillermolecules.size() << " molecules are present.");
-  std::list<molecule *> fillermolecules_list;
-  std::copy( fillermolecules.begin(),  fillermolecules.end(), std::back_inserter( fillermolecules_list ));
-//  LOG(0, fillermolecules_list.size() << " molecules have been copied.");
-  for (std::vector<molecule *>::const_iterator iter = presentmolecules.begin();
-      iter != presentmolecules.end();
-      ++iter) {
-    fillermolecules_list.remove(*iter);
-  }
-//  LOG(0, fillermolecules_list.size() << " molecules left after removal.");
-  fillermolecules.clear();
-  std::copy(fillermolecules_list.begin(), fillermolecules_list.end(), std::back_inserter( fillermolecules ));
-
-//  LOG(0, fillermolecules.size() << " molecules have been inserted.");
-
-  return ActionState::ptr(new MoleculeFillWithMoleculeState(fillermolecules,params));
-}
-
-ActionState::ptr MoleculeFillWithMoleculeAction::performUndo(ActionState::ptr _state) {
-  MoleculeFillWithMoleculeState *state = assert_cast<MoleculeFillWithMoleculeState*>(_state.get());
-
-  MoleculeListClass *MolList = World::getInstance().getMolecules();
-
-  BOOST_FOREACH(molecule *_mol, state->fillermolecules) {
-    MolList->erase(_mol);
-    if ((_mol != NULL) && (!(World::getInstance().getAllMolecules(MoleculeById(_mol->getId()))).empty())) {
-      for(molecule::iterator iter = _mol->begin();
-          !_mol->empty();
-          iter = _mol->begin()) {
-        atom *Walker = *iter;
-        World::getInstance().destroyAtom(Walker);
-      }
-      World::getInstance().destroyMolecule(_mol);
-    }
-  }
-
-  // as molecules and atoms from state are removed, we have to create a new one
-  std::vector<molecule *> fillermolecules;
-  return ActionState::ptr(new MoleculeFillWithMoleculeState(fillermolecules,state->params));
-}
-
-ActionState::ptr MoleculeFillWithMoleculeAction::performRedo(ActionState::ptr _state){
-  //MoleculeFillWithMoleculeState *state = assert_cast<MoleculeFillWithMoleculeState*>(_state.get());
-
-  STATUS("Redo of MoleculeFillWithMoleculeAction not implemented.");
-  return Action::failure;
-  //return ActionState::ptr(_state);
-}
-
-bool MoleculeFillWithMoleculeAction::canUndo() {
-  return true;
-}
-
-bool MoleculeFillWithMoleculeAction::shouldUndo() {
-  return true;
-}
-/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.def
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.def	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,53 +1,0 @@
-/*
- * FillWithMoleculeAction.def
- *
- *  Created on: Aug 26, 2010
- *      Author: heber
- */
-
-// all includes and forward declarations necessary for non-integral types below
-#include <boost/assign.hpp>
-#include <boost/filesystem/path.hpp>
-#include <vector>
-#include "LinearAlgebra/Vector.hpp"
-
-#include "Parameters/Validators/DiscreteValidator.hpp"
-#include "Parameters/Validators/DummyValidator.hpp"
-#include "Parameters/Validators/Ops_Validator.hpp"
-#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
-#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
-#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
-#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
-
-// i.e. there is an integer with variable name Z that can be found in
-// ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
-#define paramtypes (boost::filesystem::path)(Vector)(double)(double)(double)(double)(bool)
-#define paramtokens ("fill-molecule")("distances")("distance-to-molecule")("random-atom-displacement")("random-molecule-displacement")("MaxDistance")("DoRotate")
-#define paramdescriptions ("name of xyz file of filler molecule")("list of three of distances in space, one for each axis direction")("minimum distance to present molecules")("magnitude of random atom displacement")("magnitude of random molecule displacement")("maximum spatial distance")("whether to rotate or not")
-#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(false))
-#define paramreferences (fillername)(distances)(boundary)(RandAtomDisplacement)(RandMoleculeDisplacement)(MaxDistance)(DoRotate)
-#define paramvalids \
-(FilePresentValidator() && ParserFileValidator()) \
-(BoxVectorValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator()) \
-(BoxLengthValidator() || DiscreteValidator<double>(std::vector<double>(1,-1.))) \
-(DummyValidator< bool >())
-
-#define statetypes (std::vector<molecule *>)
-#define statereferences (fillermolecules)
-
-// some defines for all the names, you may use ACTION, STATE and PARAMS
-#define CATEGORY Molecule
-#define MENUNAME "molecule"
-#define MENUPOSITION 4
-#define ACTIONNAME FillWithMolecule
-#define TOKEN "fill-molecule"
-
-
-// finally the information stored in the ActionTrait specialization
-#define DESCRIPTION "fill around molecules' surface with a filler molecule"
-#define SHORTFORM "F"
-
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.hpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision df9f200764a5636d8eb51224f34c27dbd7463b9a)
+++ 	(revision )
@@ -1,22 +1,0 @@
-/*
- * FillWithMoleculeAction.hpp
- *
- *  Created on: May 10, 2010
- *      Author: heber
- */
-
-#ifndef FILLWITHMOLECULEACTION_HPP
-#define FILLWITHMOLECULEACTION_HPP
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-
-#include "Actions/Action.hpp"
-
-#include "FillWithMoleculeAction.def"
-#include "Action_impl_header.hpp"
-
-#endif // FILLWITHMOLECULEACTION_HPP