Index: tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at
===================================================================
--- tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at	(revision 3bd460af052917a45d592fa6b0fec95c039cefb1)
+++ tests/regression/Domain/AddEmptyBoundary/testsuite-domain-add-empty-boundary.at	(revision 23b0c2555391ed336a0a7589e88eb386466789ce)
@@ -3,7 +3,11 @@
 AT_SETUP([Domain - centering with defined boundary])
 AT_KEYWORDS([domain])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -c "5, 10, 15"], 0, [stdout], [stderr])
+
+file=test.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/pre/test.conf $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file  -c "5, 10, 15"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
-AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/post/test.conf], 0, [stdout], [stderr])
+AT_CHECK([diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/AddEmptyBoundary/post/test.conf], 0, [stdout], [stderr])
+
 AT_CLEANUP
Index: tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at
===================================================================
--- tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at	(revision 3bd460af052917a45d592fa6b0fec95c039cefb1)
+++ tests/regression/Domain/CenterInBox/testsuite-domain-center-in-box.at	(revision 23b0c2555391ed336a0a7589e88eb386466789ce)
@@ -3,7 +3,11 @@
 AT_SETUP([Domain - setting and centering in domain])
 AT_KEYWORDS([domain])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -b "15, 0, 15, 0, 0, 15"], 0, [stdout], [stderr])
+
+file=test.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/pre/test.conf $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file  -b "15, 0, 15, 0, 0, 15"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
-AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/post/test.conf], 0, [stdout], [stderr])
+AT_CHECK([diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterInBox/post/test.conf], 0, [stdout], [stderr])
+
 AT_CLEANUP
Index: tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at
===================================================================
--- tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at	(revision 3bd460af052917a45d592fa6b0fec95c039cefb1)
+++ tests/regression/Domain/CenterOnEdge/testsuite-domain-center-on-edge.at	(revision 23b0c2555391ed336a0a7589e88eb386466789ce)
@@ -3,7 +3,11 @@
 AT_SETUP([Domain - centering and setting domain])
 AT_KEYWORDS([domain])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -O], 0, [stdout], [stderr])
+
+file=test.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/pre/test.conf $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file  -O], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
-AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/post/test.conf], 0, [stdout], [stderr])
+AT_CHECK([diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/CenterOnEdge/post/test.conf], 0, [stdout], [stderr])
+
 AT_CLEANUP
Index: tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at
===================================================================
--- tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at	(revision 3bd460af052917a45d592fa6b0fec95c039cefb1)
+++ tests/regression/Domain/RepeatBox/testsuite-domain-repeat-box.at	(revision 23b0c2555391ed336a0a7589e88eb386466789ce)
@@ -3,28 +3,36 @@
 AT_SETUP([Domain - duplicating box])
 AT_KEYWORDS([domain])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -o xyz -d "1, 1, 1"], 0, [stdout], [stderr])
+
+file=test.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf $file], 0)
+AT_CHECK([../../molecuilder -i $file  -o xyz -d "1, 1, 1"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
 AT_CHECK([file=test.xyz; diff $file-sorted $file-sorted2], 0, [ignore], [ignore])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-x.conf], 0)
-AT_CHECK([../../molecuilder -i test-x.conf  -o xyz -d "2, 1, 1"], 0, [stdout], [stderr])
+
+file=test-x.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf $file], 0)
+AT_CHECK([../../molecuilder -i $file -o xyz -d "2, 1, 1"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-x.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-x.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
 AT_CHECK([file=test-x.xyz; diff $file-sorted $file-sorted2], 0, [ignore], [ignore])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-y.conf], 0)
-AT_CHECK([../../molecuilder -i test-y.conf  -o xyz -d "1, 2, 1"], 0, [stdout], [stderr])
+
+file=test-y.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf $file], 0)
+AT_CHECK([../../molecuilder -i $file  -o xyz -d "1, 2, 1"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-y.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-y.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
 AT_CHECK([file=test-y.xyz; diff $file-sorted $file-sorted2], 0, [ignore], [ignore])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf test-z.conf], 0)
-AT_CHECK([../../molecuilder -i test-z.conf  -o xyz -d "1, 1, 2"], 0, [stdout], [stderr])
+
+file=test-z.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/pre/test.conf $file], 0)
+AT_CHECK([../../molecuilder -i $file  -o xyz -d "1, 1, 2"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
 AT_CHECK([file=test-z.xyz;sort -n $file | grep -v "Created by" >$file-sorted], 0, [ignore], [ignore])
 AT_CHECK([file=test-z.xyz;sort -n ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/RepeatBox/post/$file  | grep -v "Created by" >$file-sorted2], 0, [ignore], [ignore])
 AT_CHECK([file=test-z.xyz; diff $file-sorted $file-sorted2], 0, [ignore], [ignore])
-#AT_CHECK([/bin/false], 12, [ignore], [ignore])
+
 AT_CLEANUP
Index: tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at
===================================================================
--- tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at	(revision 3bd460af052917a45d592fa6b0fec95c039cefb1)
+++ tests/regression/Domain/ScaleBox/testsuite-domain-scale-box.at	(revision 23b0c2555391ed336a0a7589e88eb386466789ce)
@@ -3,7 +3,11 @@
 AT_SETUP([Domain - scaling box])
 AT_KEYWORDS([domain])
-AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  --scale-box "0.5, 1., 0.9"], 0, [stdout], [stderr])
+
+file=test.conf
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/pre/test.conf $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file  --scale-box "0.5, 1., 0.9"], 0, [stdout], [stderr])
 AT_CHECK([fgrep "Box domain is now" stdout], 0, [ignore], [ignore])
-AT_CHECK([diff test.conf ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/post/test.conf], 0, [stdout], [stderr])
+AT_CHECK([diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Domain/ScaleBox/post/test.conf], 0, [stdout], [stderr])
+
 AT_CLEANUP