Index: src/Parser/Makefile.am
===================================================================
--- src/Parser/Makefile.am	(revision 4c12306495978f073faf37a21b00f168b04041bf)
+++ src/Parser/Makefile.am	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -17,4 +17,5 @@
   PdbParser.cpp \
   TremoloParser.cpp \
+  TremoloAtomInfoContainer.cpp \
   XyzParser.cpp
 
@@ -28,5 +29,7 @@
   PdbKey.hpp \
   PdbParser.hpp \
+  TremoloKey.hpp \
   TremoloParser.hpp \
+  TremoloAtomInfoContainer.hpp \
   XyzParser.hpp
 
Index: src/Parser/TremoloAtomInfoContainer.cpp
===================================================================
--- src/Parser/TremoloAtomInfoContainer.cpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
+++ src/Parser/TremoloAtomInfoContainer.cpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -0,0 +1,135 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * TremoloAtomInfoContainer.cpp
+ *
+ *  Created on: Dec 7, 2010
+ *      Author: heber
+ */
+
+#include "TremoloAtomInfoContainer.hpp"
+
+#include <iostream>
+
+
+TremoloAtomInfoContainer::TremoloAtomInfoContainer() :
+  F("0"),
+  stress("0"),
+  imprData("-"),
+  GroupMeasureTypeNo("0"),
+  extType("-"),
+  name("-"),
+  resName("-"),
+  chainID("0"),
+  resSeq("0"),
+  occupancy("0"),
+  tempFactor("0"),
+  segID("0"),
+  Charge("0"),
+  charge("0"),
+  GrpTypeNo("0"),
+  torsion("-"),
+  neighbors(std::vector<int>(0, 5))
+{}
+
+void TremoloAtomInfoContainer::set(TremoloKey::atomDataKey key, std::string value) {
+  switch (key) {
+    case TremoloKey::F :
+      F = value;
+      break;
+    case TremoloKey::stress :
+      stress = value;
+     break;
+    case TremoloKey::imprData :
+      imprData = value;
+      break;
+    case TremoloKey::GroupMeasureTypeNo :
+      GroupMeasureTypeNo = value;
+      break;
+    case TremoloKey::extType :
+      extType = value;
+      break;
+    case TremoloKey::name :
+      name = value;
+      break;
+    case TremoloKey::resName :
+      resName = value;
+      break;
+    case TremoloKey::chainID :
+      chainID = value;
+      break;
+    case TremoloKey::resSeq :
+      resSeq = value;
+      break;
+    case TremoloKey::occupancy :
+      occupancy = value;
+      break;
+    case TremoloKey::tempFactor :
+      tempFactor = value;
+      break;
+    case TremoloKey::segID :
+      segID = value;
+      break;
+    case TremoloKey::Charge :
+      Charge = value;
+      break;
+    case TremoloKey::charge :
+      charge = value;
+      break;
+    case TremoloKey::GrpTypeNo :
+      GrpTypeNo = value;
+      break;
+    case TremoloKey::torsion :
+      torsion = value;
+      break;
+    default :
+      std::cout << "Unknown key: " << key << ", value: " << value << std::endl;
+      break;
+  }
+}
+
+std::string TremoloAtomInfoContainer::get(TremoloKey::atomDataKey key) {
+  switch (key) {
+    case TremoloKey::F :
+      return F;
+    case TremoloKey::stress :
+      return stress;
+    case TremoloKey::imprData :
+      return imprData;
+    case TremoloKey::GroupMeasureTypeNo :
+      return GroupMeasureTypeNo;
+    case TremoloKey::extType :
+      return extType;
+    case TremoloKey::name :
+      return name;
+    case TremoloKey::resName :
+      return resName;
+    case TremoloKey::chainID :
+      return chainID;
+    case TremoloKey::resSeq :
+      return resSeq;
+    case TremoloKey::occupancy :
+      return occupancy;
+    case TremoloKey::tempFactor :
+      return tempFactor;
+    case TremoloKey::segID :
+      return segID;
+    case TremoloKey::Charge :
+      return Charge;
+    case TremoloKey::charge :
+      return charge;
+    case TremoloKey::GrpTypeNo :
+      return GrpTypeNo;
+    case TremoloKey::torsion :
+      return torsion;
+    default :
+      std::cout << "Unknown key: " << key << std::endl;
+      return "";
+  }
+}
+
Index: src/Parser/TremoloAtomInfoContainer.hpp
===================================================================
--- src/Parser/TremoloAtomInfoContainer.hpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
+++ src/Parser/TremoloAtomInfoContainer.hpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -0,0 +1,44 @@
+/*
+ * TremoloAtomInfoContainer.hpp
+ *
+ *  Created on: Dec 7, 2010
+ *      Author: heber
+ */
+
+#ifndef TREMOLOATOMINFOCONTAINER_HPP_
+#define TREMOLOATOMINFOCONTAINER_HPP_
+
+#include <string>
+#include <vector>
+
+#include "TremoloKey.hpp"
+
+/**
+ * Holds tremolo-specific information which is not store in the atom class.
+ */
+class TremoloAtomInfoContainer {
+public:
+  TremoloAtomInfoContainer();
+  void set(TremoloKey::atomDataKey key, std::string value);
+  std::string get(TremoloKey::atomDataKey key);
+  std::string F;
+  std::string stress;
+  std::string imprData;
+  std::string GroupMeasureTypeNo;
+  std::string extType;
+  std::string name;
+  std::string resName;
+  std::string chainID;
+  std::string resSeq;
+  std::string occupancy;
+  std::string tempFactor;
+  std::string segID;
+  std::string Charge;
+  std::string charge;
+  std::string GrpTypeNo;
+  std::string torsion;
+  std::vector<int> neighbors;
+};
+
+
+#endif /* TREMOLOATOMINFOCONTAINER_HPP_ */
Index: src/Parser/TremoloKey.hpp
===================================================================
--- src/Parser/TremoloKey.hpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
+++ src/Parser/TremoloKey.hpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -0,0 +1,43 @@
+/*
+ * TremoloKey.hpp
+ *
+ *  Created on: Dec 7, 2010
+ *      Author: heber
+ */
+
+#ifndef TREMOLOKEY_HPP_
+#define TREMOLOKEY_HPP_
+
+/**
+ * Known keys for the ATOMDATA line.
+ */
+class TremoloKey {
+public:
+  enum atomDataKey {
+    noKey,
+    x,
+    u,
+    F,
+    stress,
+    Id,
+    neighbors,
+    imprData,
+    GroupMeasureTypeNo,
+    Type,
+    extType,
+    name,
+    resName,
+    chainID,
+    resSeq,
+    occupancy,
+    tempFactor,
+    segID,
+    Charge,
+    charge,
+    GrpTypeNo,
+    torsion
+  };
+};
+
+
+#endif /* TREMOLOKEY_HPP_ */
Index: src/Parser/TremoloParser.cpp
===================================================================
--- src/Parser/TremoloParser.cpp	(revision 4c12306495978f073faf37a21b00f168b04041bf)
+++ src/Parser/TremoloParser.cpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -427,119 +427,2 @@
 }
 
-
-TremoloAtomInfoContainer::TremoloAtomInfoContainer() :
-  F("0"),
-  stress("0"),
-  imprData("-"),
-  GroupMeasureTypeNo("0"),
-  extType("-"),
-  name("-"),
-  resName("-"),
-  chainID("0"),
-  resSeq("0"),
-  occupancy("0"),
-  tempFactor("0"),
-  segID("0"),
-  Charge("0"),
-  charge("0"),
-  GrpTypeNo("0"),
-  torsion("-"),
-  neighbors(vector<int>(0, 5))
-{}
-
-void TremoloAtomInfoContainer::set(TremoloKey::atomDataKey key, string value) {
-  switch (key) {
-    case TremoloKey::F :
-      F = value;
-      break;
-    case TremoloKey::stress :
-      stress = value;
-     break;
-    case TremoloKey::imprData :
-      imprData = value;
-      break;
-    case TremoloKey::GroupMeasureTypeNo :
-      GroupMeasureTypeNo = value;
-      break;
-    case TremoloKey::extType :
-      extType = value;
-      break;
-    case TremoloKey::name :
-      name = value;
-      break;
-    case TremoloKey::resName :
-      resName = value;
-      break;
-    case TremoloKey::chainID :
-      chainID = value;
-      break;
-    case TremoloKey::resSeq :
-      resSeq = value;
-      break;
-    case TremoloKey::occupancy :
-      occupancy = value;
-      break;
-    case TremoloKey::tempFactor :
-      tempFactor = value;
-      break;
-    case TremoloKey::segID :
-      segID = value;
-      break;
-    case TremoloKey::Charge :
-      Charge = value;
-      break;
-    case TremoloKey::charge :
-      charge = value;
-      break;
-    case TremoloKey::GrpTypeNo :
-      GrpTypeNo = value;
-      break;
-    case TremoloKey::torsion :
-      torsion = value;
-      break;
-    default :
-      cout << "Unknown key: " << key << ", value: " << value << endl;
-      break;
-  }
-}
-
-string TremoloAtomInfoContainer::get(TremoloKey::atomDataKey key) {
-  switch (key) {
-    case TremoloKey::F :
-      return F;
-    case TremoloKey::stress :
-      return stress;
-    case TremoloKey::imprData :
-      return imprData;
-    case TremoloKey::GroupMeasureTypeNo :
-      return GroupMeasureTypeNo;
-    case TremoloKey::extType :
-      return extType;
-    case TremoloKey::name :
-      return name;
-    case TremoloKey::resName :
-      return resName;
-    case TremoloKey::chainID :
-      return chainID;
-    case TremoloKey::resSeq :
-      return resSeq;
-    case TremoloKey::occupancy :
-      return occupancy;
-    case TremoloKey::tempFactor :
-      return tempFactor;
-    case TremoloKey::segID :
-      return segID;
-    case TremoloKey::Charge :
-      return Charge;
-    case TremoloKey::charge :
-      return charge;
-    case TremoloKey::GrpTypeNo :
-      return GrpTypeNo;
-    case TremoloKey::torsion :
-      return torsion;
-    default :
-      cout << "Unknown key: " << key << endl;
-      return "";
-  }
-}
-
Index: src/Parser/TremoloParser.hpp
===================================================================
--- src/Parser/TremoloParser.hpp	(revision 4c12306495978f073faf37a21b00f168b04041bf)
+++ src/Parser/TremoloParser.hpp	(revision 031e2c6660707d072a402cb12517f617d42c8d3c)
@@ -12,63 +12,8 @@
 #include "Parser/FormatParser.hpp"
 
+#include "TremoloKey.hpp"
+#include "TremoloAtomInfoContainer.hpp"
+
 class molecule;
-
-/**
- * Known keys for the ATOMDATA line.
- */
-class TremoloKey {
-public:
-  enum atomDataKey {
-    noKey,
-    x,
-    u,
-    F,
-    stress,
-    Id,
-    neighbors,
-    imprData,
-    GroupMeasureTypeNo,
-    Type,
-    extType,
-    name,
-    resName,
-    chainID,
-    resSeq,
-    occupancy,
-    tempFactor,
-    segID,
-    Charge,
-    charge,
-    GrpTypeNo,
-    torsion
-  };
-};
-
-/**
- * Holds tremolo-specific information which is not store in the atom class.
- */
-class TremoloAtomInfoContainer {
-public:
-  TremoloAtomInfoContainer();
-  void set(TremoloKey::atomDataKey key, std::string value);
-  std::string get(TremoloKey::atomDataKey key);
-  std::string F;
-  std::string stress;
-  std::string imprData;
-  std::string GroupMeasureTypeNo;
-  std::string extType;
-  std::string name;
-  std::string resName;
-  std::string chainID;
-  std::string resSeq;
-  std::string occupancy;
-  std::string tempFactor;
-  std::string segID;
-  std::string Charge;
-  std::string charge;
-  std::string GrpTypeNo;
-  std::string torsion;
-  std::vector<int> neighbors;
-};
 
 /**